ALTER TABLE USERS ADD (CHANGE_PASWD_AT_LOGIN NUMBER(4));
ALTER TABLE USERS ADD (LOGIN_FAILED NUMBER(4));
ALTER TABLE USERS ADD (PASSWD_LAST_CHANGED DATE);
ALTER TABLE USERS ADD (EXPIRE_ACCOUNT VARCHAR2 (80));
ALTER TABLE USERS ADD (USER_AUTH CHAR (2));
ALTER TABLE USERS ADD (LOGINTONEWREC NUMBER(4));
ALTER TABLE USERS ADD (GROUPADMIN NUMBER(4));
ALTER TABLE USERS ADD (USER_OFFSET VARCHAR2 (4));
ALTER TABLE USERS ADD (USERADMIN NUMBER(4));
ALTER TABLE USERS ADD (VIEWLOGS NUMBER(4));
ALTER TABLE USERS ADD (VIEWREPORTS NUMBER(4));


CREATE TABLE TRACKOLDPASSWD
(
ID NUMBER(4) NOT NULL,
USERID NUMBER(4) NOT NULL,
PASSWORD VARCHAR2 (50) NOT NULL

) 
LOGGING
NOCACHE
NOPARALLEL;


CREATE SEQUENCE TRACKOLDPASSWD_ID_SEQ
  START WITH 1
  NOMAXVALUE
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

CREATE OR REPLACE TRIGGER TRACKOLDPASSWD_ID_TRIGGER
  BEFORE INSERT ON TRACKOLDPASSWD
  REFERENCING NEW AS NEW OLD AS OLD
  FOR EACH ROW
BEGIN
  SELECT TRACKOLDPASSWD_ID_SEQ.NEXTVAL INTO :NEW.ID FROM DUAL;
END;
/
show errors;



ALTER TABLE TRACKOLDPASSWD  MODIFY (USERID DEFAULT 0);
ALTER TABLE TRACKOLDPASSWD ADD (
  PRIMARY KEY (ID)
  USING INDEX);


CREATE TABLE FAVORITES 
(
 USERID NUMBER(4) NOT NULL,
 FOLDER_ID NUMBER(4) NOT NULL
)
LOGGING
NOCACHE
NOPARALLEL;

ALTER TABLE FAVORITES  MODIFY (USERID DEFAULT 0);
ALTER TABLE FAVORITES  MODIFY (FOLDER_ID DEFAULT 1);

CREATE TABLE ADVANCED_ACL
(
 GROUP_ID NUMBER(4)  ,
 USER_ID NUMBER(4)  ,
 FILE_ID NUMBER(4)  ,
 FOLDER_ID NUMBER(4)  ,
 OWLREAD NUMBER(4)  ,
 OWLWRITE NUMBER(4)  ,
 OWLVIEWLOG NUMBER(4)  ,
 OWLDELETE NUMBER(4)  ,
 OWLCOPY NUMBER(4)  ,
 OWLMOVE NUMBER(4)  ,
 OWLPROPERTIES NUMBER(4)  ,
 OWLUPDATE NUMBER(4)  ,
 OWLCOMMENT NUMBER(4)  ,
 OWLCHECKIN NUMBER(4)  ,
 OWLEMAIL NUMBER(4)  ,
 OWLRELSEARCH NUMBER(4)  ,
 OWLSETACL NUMBER(4)  ,
 OWLMONITOR NUMBER(4)  
)
LOGGING
NOCACHE
NOPARALLEL;

ALTER TABLE ADVANCED_ACL  MODIFY (OWLREAD DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLWRITE DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLVIEWLOG DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLDELETE DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLCOPY DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLMOVE DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLPROPERTIES DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLUPDATE DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLCOMMENT DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLCHECKIN DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLEMAIL DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLRELSEARCH DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLSETACL DEFAULT 0);
ALTER TABLE ADVANCED_ACL  MODIFY (OWLMONITOR DEFAULT 0);


INSERT INTO ADVANCED_ACL VALUES (NULL,0,NULL,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0);


ALTER TABLE PREFS ADD (THUMB_DISP_STATUS NUMBER(4));
ALTER TABLE PREFS ADD (THUMB_DISP_DOC_NUM NUMBER(4));
ALTER TABLE PREFS ADD (THUMB_DISP_IMAGE_INFO NUMBER(4));
ALTER TABLE PREFS ADD (THUMB_DISP_VERSION NUMBER(4));
ALTER TABLE PREFS ADD (THUMB_DISP_SIZE NUMBER(4));
ALTER TABLE PREFS ADD (THUMB_DISP_POSTED NUMBER(4));
ALTER TABLE PREFS ADD (THUMB_DISP_UPDATED NUMBER(4));
ALTER TABLE PREFS ADD (THUMB_DISP_MODIFIED NUMBER(4));
ALTER TABLE PREFS ADD (THUMB_DISP_ACTION NUMBER(4));
ALTER TABLE PREFS ADD (THUMB_DISP_HELD NUMBER(4));
ALTER TABLE PREFS ADD (SELF_CREATE_HOMEDIR NUMBER(4));
ALTER TABLE PREFS ADD (SELF_CAPTCHA NUMBER(4));
ALTER TABLE PREFS ADD (INFO_PANEL_WIDE NUMBER(4));
ALTER TABLE PREFS ADD (TRACK_FAVORITES NUMBER(4));
ALTER TABLE PREFS ADD (EXPAND_DISP_UPDATED NUMBER(4));
ALTER TABLE PREFS ADD (COLLAPSE_DISP_UPDATED NUMBER(4));
ALTER TABLE PREFS ADD (EXPAND_SEARCH_DISP_UPDATED NUMBER(4));
ALTER TABLE PREFS ADD (COLLAPSE_SEARCH_DISP_UPDATED NUMBER(4));

ALTER TABLE PREFS MODIFY (EXPAND_DISP_UPDATED DEFAULT NULL);
ALTER TABLE PREFS MODIFY (COLLAPSE_DISP_UPDATED DEFAULT NULL);
ALTER TABLE PREFS MODIFY (EXPAND_SEARCH_DISP_UPDATED DEFAULT NULL);
ALTER TABLE PREFS MODIFY (COLLAPSE_SEARCH_DISP_UPDATED DEFAULT NULL);

ALTER TABLE PREFS ADD (THUMBNAILS_TOOL_PATH VARCHAR2 (255));
ALTER TABLE PREFS ADD (THUMBNAILS_VIDEO_TOOL_PATH VARCHAR2 (255));
ALTER TABLE PREFS ADD (THUMBNAILS_VIDEO_TOOL_OPT VARCHAR2 (255));

ALTER TABLE PREFS ADD (THUMBNAILS NUMBER(4));
ALTER TABLE PREFS ADD (THUMBNAILS_SMALL_WIDTH NUMBER(4));
ALTER TABLE PREFS ADD (THUMBNAILS_MED_WIDTH NUMBER(4));
ALTER TABLE PREFS ADD (THUMBNAILS_LARGE_WIDTH NUMBER(4));
ALTER TABLE PREFS ADD (THUMBNAIL_VIEW_COLUMNS NUMBER(4));
ALTER TABLE PREFS ADD (RTFTOTEXT_PATH VARCHAR2 (250));

ALTER TABLE PREFS ADD (MIN_PASS_LENGTH NUMBER(4));
ALTER TABLE PREFS ADD (MIN_USERNAME_LENGTH NUMBER(4));
ALTER TABLE PREFS ADD (MIN_PASS_NUMERIC NUMBER(4));
ALTER TABLE PREFS ADD (MIN_PASS_SPECIAL NUMBER(4));
ALTER TABLE PREFS ADD (ENABLE_LOCK_ACCOUNT NUMBER(4));
ALTER TABLE PREFS ADD (LOCK_ACCOUNT_BAD_PASSWORD NUMBER(4));
ALTER TABLE PREFS ADD (TRACK_USER_PASSWORDS NUMBER(4));
ALTER TABLE PREFS ADD (CHANGE_PASSWORD_EVERY NUMBER(4));
ALTER TABLE PREFS ADD (COLLAPSE_SEARCH_DISP_DOC_NUM NUMBER(4));
ALTER TABLE PREFS ADD (EXPAND_SEARCH_DISP_DOC_NUM NUMBER(4));
ALTER TABLE PREFS ADD (DISPLAY_PASSWORD_OVERRIDE NUMBER(4));

ALTER TABLE PREFS ADD (FILEDESCREQ NUMBER(4));
ALTER TABLE PREFS ADD (FOLDERDESCREQ NUMBER(4));
ALTER TABLE PREFS ADD (SHOW_USER_INFO NUMBER(4));

ALTER TABLE PREFS ADD (COLPS_SEARCH_DISP_DOC_FIELDS NUMBER(4));
ALTER TABLE PREFS ADD (EXPAND_SEARCH_DISP_DOC_FIELDS NUMBER(4));
ALTER TABLE PREFS ADD (COLLAPSE_DISP_DOC_FIELDS NUMBER(4));
ALTER TABLE PREFS ADD (EXPAND_DISP_DOC_FIELDS NUMBER(4));


ALTER TABLE DOCFIELDS ADD (SHOW_IN_LIST NUMBER(4));


ALTER TABLE MEMBERGROUP MODIFY (GROUPID DEFAULT NULL);


CREATE INDEX ACL_FOLDERID ON ADVANCED_ACL
(FOLDER_ID)
LOGGING
NOPARALLEL;

CREATE INDEX ACL_FILEID ON ADVANCED_ACL
(FILE_ID)
LOGGING
NOPARALLEL;

CREATE INDEX ACL_USERID ON ADVANCED_ACL
(USER_ID)
LOGGING
NOPARALLEL;

CREATE INDEX ACL_GROUPID_INDEX ON ADVANCED_ACL
(GROUP_ID)
LOGGING
NOPARALLEL;

CREATE INDEX FILES_FILETYPE ON FILES
(URL)
LOGGING
NOPARALLEL;

INSERT INTO PREFS (ID,EMAIL_FROM,EMAIL_FROMNAME,EMAIL_REPLYTO,EMAIL_SERVER,EMAIL_SUBJECT,LOOKATHD,LOOKATHDDEL,DEF_FILE_SECURITY,DEF_FILE_GROUP_OWNER,DEF_FILE_OWNER,DEF_FILE_TITLE,DEF_FILE_META,DEF_FOLD_SECURITY,DEF_FOLD_GROUP_OWNER,DEF_FOLD_OWNER,MAX_FILESIZE,TMPDIR,TIMEOUT,EXPAND,VERSION_CONTROL,RESTRICT_VIEW,HIDE_BACKUP,DBDUMP_PATH,GZIP_PATH,TAR_PATH,UNZIP_PATH,POD2HTML_PATH,PDFTOTEXT_PATH,WORDTOTEXT_PATH,FILE_PERM,FOLDER_PERM,LOGGING,LOG_FILE,LOG_LOGIN,LOG_REC_PER_PAGE,REC_PER_PAGE,SELF_REG,SELF_REG_QUOTA,SELF_REG_NOTIFY,SELF_REG_ATTACHFILE,SELF_REG_DISABLED,SELF_REG_NOPREFACCES,SELF_REG_MAXSESSIONS,SELF_REG_GROUP,ANON_RO,ANON_USER,FILE_ADMIN_GROUP,FORGOT_PASS,COLLECT_TRASH,TRASH_CAN_LOCATION,ALLOW_POPUP,ALLOW_CUSTPOPUP,STATUS_BAR_LOCATION,REMEMBER_ME,COOKIE_TIMEOUT,USE_SMTP,USE_SMTP_AUTH,SMTP_PASSWD,SEARCH_BAR,BULK_BUTTONS,ACTION_BUTTONS,FOLDER_TOOLS,PREF_BAR,SMTP_AUTH_LOGIN,EXPAND_DISP_STATUS,EXPAND_DISP_DOC_NUM,EXPAND_DISP_DOC_TYPE,EXPAND_DISP_TITLE,EXPAND_DISP_VERSION,EXPAND_DISP_FILE,EXPAND_DISP_SIZE,EXPAND_DISP_POSTED,EXPAND_DISP_MODIFIED,EXPAND_DISP_ACTION,EXPAND_DISP_HELD,COLLAPSE_DISP_STATUS,COLLAPSE_DISP_DOC_NUM,COLLAPSE_DISP_DOC_TYPE,COLLAPSE_DISP_TITLE,COLLAPSE_DISP_VERSION,COLLAPSE_DISP_FILE,COLLAPSE_DISP_SIZE,COLLAPSE_DISP_POSTED,COLLAPSE_DISP_MODIFIED,COLLAPSE_DISP_ACTION,COLLAPSE_DISP_HELD,EXPAND_SEARCH_DISP_SCORE,EXPAND_SEARCH_DISP_FOLDER_PATH,EXPAND_SEARCH_DISP_DOC_TYPE,EXPAND_SEARCH_DISP_FILE,EXPAND_SEARCH_DISP_SIZE,EXPAND_SEARCH_DISP_POSTED,EXPAND_SEARCH_DISP_MODIFIED,EXPAND_SEARCH_DISP_ACTION,COLLAPSE_SEARCH_DISP_SCORE,COLPS_SEARCH_DISP_FLD_PATH,COLLAPSE_SEARCH_DISP_DOC_TYPE,COLLAPSE_SEARCH_DISP_FILE,COLLAPSE_SEARCH_DISP_SIZE,COLLAPSE_SEARCH_DISP_POSTED,COLLAPSE_SEARCH_DISP_MODIFIED,COLLAPSE_SEARCH_DISP_ACTION,HIDE_FOLDER_DOC_COUNT,OLD_ACTION_ICONS,SEARCH_RESULT_FOLDERS,RESTORE_FILE_PREFIX,MAJOR_REVISION,MINOR_REVISION,DOC_ID_PREFIX,DOC_ID_NUM_DIGITS,VIEW_DOC_IN_NEW_WINDOW,ADMIN_LOGIN_TO_BROWSE_PAGE,SAVE_KEYWORDS_TO_DB,SELF_REG_HOMEDIR,SELF_REG_FIRSTDIR,VIRUS_PATH,PEER_REVIEW,PEER_OPT,FOLDER_SIZE,DOWNLOAD_FOLDER_ZIP,DISPLAY_PASSWORD_OVERRIDE,THUMB_DISP_STATUS,THUMB_DISP_DOC_NUM,THUMB_DISP_IMAGE_INFO,THUMB_DISP_VERSION,THUMB_DISP_SIZE,THUMB_DISP_POSTED,THUMB_DISP_MODIFIED,THUMB_DISP_ACTION,THUMB_DISP_HELD,THUMBNAILS_TOOL_PATH,THUMBNAILS_VIDEO_TOOL_PATH,THUMBNAILS_VIDEO_TOOL_OPT,THUMBNAILS,THUMBNAILS_SMALL_WIDTH,THUMBNAILS_MED_WIDTH,THUMBNAILS_LARGE_WIDTH,THUMBNAIL_VIEW_COLUMNS,RTFTOTEXT_PATH,MIN_PASS_LENGTH,MIN_USERNAME_LENGTH,MIN_PASS_NUMERIC,MIN_PASS_SPECIAL,ENABLE_LOCK_ACCOUNT,LOCK_ACCOUNT_BAD_PASSWORD,TRACK_USER_PASSWORDS,CHANGE_PASSWORD_EVERY,FOLDERDESCREQ,SHOW_USER_INFO,FILEDESCREQ,COLLAPSE_SEARCH_DISP_DOC_NUM,EXPAND_SEARCH_DISP_DOC_NUM,COLPS_SEARCH_DISP_DOC_FIELDS,EXPAND_SEARCH_DISP_DOC_FIELDS,COLLAPSE_DISP_DOC_FIELDS,EXPAND_DISP_DOC_FIELDS,SELF_CREATE_HOMEDIR,SELF_CAPTCHA,INFO_PANEL_WIDE,TRACK_FAVORITES,EXPAND_DISP_UPDATED,COLLAPSE_DISP_UPDATED,EXPAND_SEARCH_DISP_UPDATED,COLLAPSE_SEARCH_DISP_UPDATED,THUMB_DISP_UPDATED) VALUES (1,'owl@ddol.es','OWL','owl@ddol.es','localhost','[OWL] : AUTOMATED MAIL','false',1,0,0,1,'<font color=red>No Info</font>','not in',0,0,1,51200000,'/tmp',600,1,1,0,1,'/usr/bin/mysqldump','/usr/bin/gzip','/bin/tar','/usr/bin/unzip','','/usr/bin/pdftotext','/usr/local/bin/antiword',0,0,0,1,1,25,0,0,0,0,0,0,0,0,1,0,2,2,0,0,'',1,1,1,0,30,0,0,'',2,1,1,1,1,'',1,0,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,1,'',1,0,'ABC-',5,0,0,0,1,1,'',0,1,1,1,0,1,0,1,1,1,1,1,1,1,'/usr/bin/convert','/usr/local/bin/mplayer',' -vo png -ss 0:05 -frames 2 -nosound -really-quiet',1,25,50,100,4,'/usr/local/bin/unrtf',8,8,0,0,0,4,10,90,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0);
